aboutsummaryrefslogtreecommitdiffstats
path: root/scripts
diff options
context:
space:
mode:
authorRichard Weickelt <richard@weickelt.de>2019-04-30 22:50:15 +0200
committerRichard Weickelt <richard@weickelt.de>2019-05-06 15:38:17 +0000
commit8877aae0050e6323b79b1d77d83309a2928724ec (patch)
tree5d69f218213b4c824df31a9eb58bb921c5bfbfb5 /scripts
parent54eb11d9b1d500d6fd91be2b0add49d8eff7603b (diff)
Add scripts to build Qbs and run autotests
These scripts may be used by contributors to run a sanity check on their changes. Especially people new to the project might be clueless how to build and run autotests. These scripts may later be used for CI as well. Both scripts work in the Debian Docker image. Change-Id: Ib51ac5fadcc90b3a220003ba2c3021bb3815e1bc Reviewed-by: Christian Kandeler <christian.kandeler@qt.io> Reviewed-by: Ivan Komissarov <ABBAPOH@gmail.com>
Diffstat (limited to 'scripts')
-rwxr-xr-xscripts/build-qbs-with-qbs.sh96
-rwxr-xr-xscripts/build-qbs-with-qmake.sh83
2 files changed, 179 insertions, 0 deletions
diff --git a/scripts/build-qbs-with-qbs.sh b/scripts/build-qbs-with-qbs.sh
new file mode 100755
index 000000000..ff747622c
--- /dev/null
+++ b/scripts/build-qbs-with-qbs.sh
@@ -0,0 +1,96 @@
+#!/usr/bin/env bash
+#############################################################################
+##
+## Copyright (C) 2019 Richard Weickelt.
+## Contact: https://www.qt.io/licensing/
+##
+## This file is part of Qbs.
+##
+## $QT_BEGIN_LICENSE:LGPL$
+## Commercial License Usage
+## Licensees holding valid commercial Qt licenses may use this file in
+## accordance with the commercial license agreement provided with the
+## Software or, alternatively, in accordance with the terms contained in
+## a written agreement between you and The Qt Company. For licensing terms
+## and conditions see https://www.qt.io/terms-conditions. For further
+## information use the contact form at https://www.qt.io/contact-us.
+##
+## GNU Lesser General Public License Usage
+## Alternatively, this file may be used under the terms of the GNU Lesser
+## General Public License version 3 as published by the Free Software
+## Foundation and appearing in the file LICENSE.LGPL3 included in the
+## packaging of this file. Please review the following information to
+## ensure the GNU Lesser General Public License version 3 requirements
+## will be met: https://www.gnu.org/licenses/lgpl-3.0.html.
+##
+## GNU General Public License Usage
+## Alternatively, this file may be used under the terms of the GNU
+## General Public License version 2.0 or (at your option) the GNU General
+## Public license version 3 or any later version approved by the KDE Free
+## Qt Foundation. The licenses are as published by the Free Software
+## Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3
+## included in the packaging of this file. Please review the following
+## information to ensure the GNU General Public License requirements will
+## be met: https://www.gnu.org/licenses/gpl-2.0.html and
+## https://www.gnu.org/licenses/gpl-3.0.html.
+##
+## $QT_END_LICENSE$
+##
+#############################################################################
+set -e
+
+#
+# It might be desired to keep settings for Qbs testing
+# in a separate folder.
+#
+export QBS_AUTOTEST_SETTINGS_DIR="${QBS_AUTOTEST_SETTINGS_DIR:-/tmp/qbs-settings}"
+
+#
+# Additional build options
+#
+BUILD_OPTIONS="\
+ ${QBS_BUILD_PROFILE:+profile:${QBS_BUILD_PROFILE}} \
+ modules.qbsbuildconfig.enableAddressSanitizer:true \
+ modules.qbsbuildconfig.enableProjectFileUpdates:true \
+ modules.qbsbuildconfig.enableUnitTests:true \
+"
+
+#
+# Build all default products of Qbs
+#
+qbs resolve ${BUILD_OPTIONS}
+qbs build ${BUILD_OPTIONS}
+qbs build -p "qbs documentation" ${BUILD_OPTIONS}
+
+#
+# Set up profiles for the freshly built Qbs if not
+# explicitly specified otherwise
+#
+if [ -z "${QBS_AUTOTEST_PROFILE}" ]; then
+
+ export QBS_AUTOTEST_PROFILE=autotestprofile
+ RUN_OPTIONS="\
+ --settings-dir ${QBS_AUTOTEST_SETTINGS_DIR} \
+ "
+
+ qbs run -p qbs_app ${BUILD_OPTIONS} -- setup-toolchains \
+ ${RUN_OPTIONS} \
+ --detect
+
+ qbs run -p qbs_app ${BUILD_OPTIONS} -- setup-qt \
+ ${RUN_OPTIONS} \
+ "${QMAKE_PATH:-$(which qmake)}" ${QBS_AUTOTEST_PROFILE}
+
+ qbs run -p qbs_app ${BUILD_OPTIONS} -- config \
+ ${RUN_OPTIONS} \
+ ${QBS_AUTOTEST_PROFILE}.baseProfile gcc
+
+ # QBS_AUTOTEST_PROFILE has been added to the environment
+ # which requires a resolve step
+ qbs resolve ${BUILD_OPTIONS}
+fi
+
+#
+# Run all autotests with QBS_AUTOTEST_PROFILE
+#
+qbs build -p "autotest-runner" ${BUILD_OPTIONS}
diff --git a/scripts/build-qbs-with-qmake.sh b/scripts/build-qbs-with-qmake.sh
new file mode 100755
index 000000000..f06501e30
--- /dev/null
+++ b/scripts/build-qbs-with-qmake.sh
@@ -0,0 +1,83 @@
+#!/usr/bin/env bash
+#############################################################################
+##
+## Copyright (C) 2019 Richard Weickelt.
+## Contact: https://www.qt.io/licensing/
+##
+## This file is part of Qbs.
+##
+## $QT_BEGIN_LICENSE:LGPL$
+## Commercial License Usage
+## Licensees holding valid commercial Qt licenses may use this file in
+## accordance with the commercial license agreement provided with the
+## Software or, alternatively, in accordance with the terms contained in
+## a written agreement between you and The Qt Company. For licensing terms
+## and conditions see https://www.qt.io/terms-conditions. For further
+## information use the contact form at https://www.qt.io/contact-us.
+##
+## GNU Lesser General Public License Usage
+## Alternatively, this file may be used under the terms of the GNU Lesser
+## General Public License version 3 as published by the Free Software
+## Foundation and appearing in the file LICENSE.LGPL3 included in the
+## packaging of this file. Please review the following information to
+## ensure the GNU Lesser General Public License version 3 requirements
+## will be met: https://www.gnu.org/licenses/lgpl-3.0.html.
+##
+## GNU General Public License Usage
+## Alternatively, this file may be used under the terms of the GNU
+## General Public License version 2.0 or (at your option) the GNU General
+## Public license version 3 or any later version approved by the KDE Free
+## Qt Foundation. The licenses are as published by the Free Software
+## Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3
+## included in the packaging of this file. Please review the following
+## information to ensure the GNU General Public License requirements will
+## be met: https://www.gnu.org/licenses/gpl-2.0.html and
+## https://www.gnu.org/licenses/gpl-3.0.html.
+##
+## $QT_END_LICENSE$
+##
+#############################################################################
+set -e
+
+#
+# It might be desired to keep settings for Qbs testing
+# in a separate folder.
+#
+export QBS_AUTOTEST_SETTINGS_DIR="${QBS_AUTOTEST_SETTINGS_DIR:-/tmp/qbs-settings}"
+
+#
+# Build all default products of Qbs
+#
+qmake -r qbs.pro \
+ CONFIG+=qbs_enable_unit_tests \
+ CONFIG+=qbs_enable_project_file_updates
+make -j $(nproc --all)
+make docs
+
+#
+# Set up profiles for the freshly built Qbs if not
+# explicitly specified otherwise
+#
+if [ -z "${QBS_AUTOTEST_PROFILE}" ]; then
+
+ export QBS_AUTOTEST_PROFILE=autotestprofile
+ RUN_OPTIONS="\
+ --settings-dir ${QBS_AUTOTEST_SETTINGS_DIR} \
+ "
+
+ ./bin/qbs setup-toolchains \
+ ${RUN_OPTIONS} \
+ --detect
+
+ ./bin/qbs setup-qt \
+ ${RUN_OPTIONS} \
+ "${QMAKE_PATH:-$(which qmake)}" ${QBS_AUTOTEST_PROFILE}
+
+ ./bin/qbs config \
+ ${RUN_OPTIONS} \
+ ${QBS_AUTOTEST_PROFILE}.baseProfile gcc
+
+fi
+
+
+make check -j $(nproc --all)